// PROJECT  :RegisterLevelInput
// PURPOSE  :Support for Towards Better Code: Register-Level Input
// COURSE   :ICS3U
// AUTHOR   :C. D'Arcy
// DATE     :2021 05 07
// MCU      :328P
// STATUS   :Working
// REFERENCE:http://darcy.rsgc.on.ca/ACES/TEI3M/ArduinoCode/TowardsBetterCode.html#registers

#include  <TimerOne.h>  
volatile uint8_t switchStates; 
volatile boolean triggered = false;
 
void setup() {
  Serial.begin(9600);
  while(!Serial);
  DDRD = B00000011;                    //aka pinMode(0-1, INPUT); pinMode(2-7, INPUT);
  Timer1.initialize(2000000);           // initialize timer1, and set a 2 second period
  Timer1.attachInterrupt(readSwitches); // attaches readSwitches() as a timer overflow interrupt
}  

void readSwitches(){
  switchStates = PIND;
  triggered = true;
}

void loop() {
  if (triggered){
    triggered = false;
    Serial.println(switchStates>>2);
  }
}
